//
//  XmlManager.m
//  Mobile1004Story
//
//  Created by 이재동 on 11. 9. 14..
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "XmlManager.h"
#import "XmlParser.h"

@implementation XmlManager

//post 방식으로 받을때 사용 url 대신 미리 post로 받은 data를 인자로 준다.
-(NSMutableDictionary*)GetXmlDictDataByData:(NSData*) data elementFile:(NSString*) fileName
{
    NSString *path = [[NSBundle mainBundle] bundlePath];
    NSString *finalPath = [path stringByAppendingPathComponent:fileName];
    NSMutableDictionary *namesPlist = [[NSMutableDictionary alloc] initWithContentsOfFile:finalPath];
    NSMutableArray *elementNameArray = (NSMutableArray*)[namesPlist objectForKey:@"names"];  
    NSString *modelName = (NSString*)[namesPlist objectForKey:@"model"];        
    
    XmlParser* parser = [[XmlParser alloc] init];       
    NSMutableDictionary *xmlDict = [[parser parseContentByData:data startElementName:modelName elementNames:elementNameArray] objectAtIndex:0];                  
    
    [namesPlist release];
    [parser release];
    return xmlDict;
}

//여러개의 데이터를 data인자로 받음 tableview에 사용
-(NSMutableArray*)GetXmlArrayDataByData:(NSData*) data elementFile:(NSString*) fileName
{
    NSString *path = [[NSBundle mainBundle] bundlePath];
    NSString *finalPath = [path stringByAppendingPathComponent:fileName];
    NSMutableDictionary *namesPlist = [[NSMutableDictionary alloc] initWithContentsOfFile:finalPath];
    NSMutableArray *elementNameArray = (NSMutableArray*)[namesPlist objectForKey:@"names"];  
    NSString *modelName = (NSString*)[namesPlist objectForKey:@"model"];            
    
    XmlParser* parser = [[XmlParser alloc] init]; 
    NSMutableArray *xmlArray = [parser parseContentByData:data startElementName:modelName elementNames:elementNameArray];
    [namesPlist release];
    [parser release];        
    return xmlArray;
}


-(NSData*)GetXmlData:(NSURL*) url isPostData:(BOOL) isPost
{
    NSMutableURLRequest* feedRequest = [NSMutableURLRequest requestWithURL:url cachePolicy: NSURLRequestUseProtocolCachePolicy timeoutInterval:10];
    if(isPost == YES)
    {
        [feedRequest setHTTPMethod:@"POST"];
    }
    NSError* theError = nil;
	NSData* xmlData = [NSURLConnection sendSynchronousRequest:feedRequest returningResponse:nil error:&theError];             

//    //data확인
//    NSString *str = [[NSString alloc] initWithData:xmlData encoding:NSUTF8StringEncoding];    
//    NSLog(@"data : %@ ",str);
    
    if(theError != nil || xmlData ==nil)
    {        
        //네트워크가 잘못됬거나 data를 가져 오지 못했을 경우 nil return
        return nil; 
    }
    else
    {
        return xmlData;
    }
}
@end
