//
//  LoginXmlParser.m
//  Mobile1004Story
//
//  Created by 이재동 on 11. 9. 6..
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "XmlParser.h"

@implementation XmlParser

-(void) dealloc
{
    [parser release];    
    [xmlDataArray release];
    [elementStack release];
    [nullElementArray release];
    
    parser = nil;
    xmlDataArray = nil;
    elementStack = nil;
    nullElementArray = nil;
    
    [super dealloc];
}

- (id) init
{
    if((self = [super init]) != nil)
    {
        xmlDataArray = [[NSMutableArray alloc] init];
        elementStack = [[NSMutableArray alloc] init];
        nullElementArray =[[NSMutableArray alloc] init];
    }
    
    return self;
}

- (void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qualifiedName attributes:(NSDictionary *)attributeDict
{
    if([elementName isEqualToString:startElement] == TRUE)
    {
          [elementStack addObject:[[[NSMutableDictionary alloc] init] autorelease]];        
    }    
    
    if([elementNameArray containsObject:elementName])
    {   
        //널일경우 따로 nullelementarray에 넣어둔뒤 나중에 값대신 ""를 넣는다.
        if([[attributeDict objectForKey:@"i:nil"] isEqualToString:@"true"])
        {
            [nullElementArray addObject:elementName];            
        }        
        
        NSString *element = [NSString stringWithString:elementName];    
        [elementStack addObject:element];        
    }    
}

- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName
{    
    if([elementName isEqualToString:startElement] == TRUE)
    {
        NSMutableDictionary *data =(NSMutableDictionary*)[elementStack lastObject];        
        
        [xmlDataArray addObject:data];
    
        [elementStack removeLastObject];        
    }			
    if([elementStack containsObject:elementName])
    {
        [elementStack removeLastObject];    
    }
}

- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string
{ 
    //trim을 쓰자면 이걸 쓰고 안하면 그냥 string 값을 넣어도 된다.
    NSCharacterSet *characterSet = [NSCharacterSet whitespaceAndNewlineCharacterSet];
    NSString *trimmedValue = [string stringByTrimmingCharactersInSet:characterSet];
    
     if([trimmedValue length] == 0)
    {
        return;    
    }
    
    id element = [elementStack lastObject];    
    
    if([element isKindOfClass:[NSString class]])
    {
        NSUInteger count = [elementStack count];
        NSUInteger index = count -2;
        id parentElement = [elementStack objectAtIndex:index];                               
        
        NSMutableDictionary *dataInfoDict = (NSMutableDictionary*)parentElement;        
        
        //NSXmlparser버그로 인해서 첫글자가 숫자일경우 짤려서 foundCharacters가 두번 호출된다.
        if([element isEqualToString:@"CmtContent"])
        {
            if([[dataInfoDict allKeys] containsObject:element])
            {                
                NSString* previousString = (NSString*)[dataInfoDict objectForKey:element];
                trimmedValue =[previousString stringByAppendingString:trimmedValue]; 
            }
        }
        
        [dataInfoDict setObject:trimmedValue forKey:element]; 
    }    
}

-(NSMutableArray*)parseContent: (NSURL*) url startElementName:(NSString*) startName elementNames:(NSMutableArray*) names;
{ 
    NSXMLParser* xmlParser = [[NSXMLParser alloc] initWithContentsOfURL:url];
    startElement = (NSString*) startName;
    elementNameArray = (NSMutableArray*) names;
    [xmlParser setDelegate:self];                             
    [xmlParser parse];
    [xmlParser release];    
    
    //만약 네트워크가 접속이 안되어 있거나 xmlparsing을 못하면 nil을 던진다.
    if([xmlDataArray count] ==0)
    {
         return nil;   
    }    

    return [NSMutableArray arrayWithArray:xmlDataArray];
}

//post 방식일때 사용
-(NSMutableArray*)parseContentByData: (NSData*) data startElementName:(NSString*) startName elementNames:(NSMutableArray*) names;
{
//    //data확인
//    NSString *str = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];    
//    NSLog(@"data : %@ ",str);
    
    NSXMLParser* xmlParser = [[NSXMLParser alloc] initWithData:data];
    startElement = (NSString*) startName;
    elementNameArray = (NSMutableArray*) names;
    [xmlParser setDelegate:self];                             
    [xmlParser parse];
    [xmlParser release];    
    
    //만약 네트워크가 접속이 안되어 있거나 xmlparsing을 못하면 nil을 던진다.
    if([xmlDataArray count] ==0)
    {
        return nil;   
    }    
    
    return [NSMutableArray arrayWithArray:xmlDataArray];
}
@end
